;in-game display routines & interrupts for Crates
;by: Robbie McElrath

gs_off:
	di
	im	1
	ld	a,6
	out	(4),a ;lowest frequency
	ld	a,$0B
	out	(3),a ;regular interrupts
	ei
	ret

gs_on:
	di

	ld	hl,$8B00
	ld	a,h
	ld	i,a
	ld	de,$8B01
	ld	c,l
	ld	b,e
	ld	(hl),$8A
	ldir
	ld	hl,Int
	ld	de,$8A8A
	ld	bc,3
	ldir

	xor	a
	out	(4),a ;fastest frequency
	ld	a,10
	out	(3),a
	im	2
	ei
	ret

Int:
	jp	Interrupt

Interrupt:
	ex	af,af'
	exx
	xor	a
	out	(3),a

	ld	hl,smc1
	inc	(hl)
	ld	hl,buf
	ld	bc,$0C20
int_1:
	push	bc
	ld	a,c
	call	lcd_delay
	out	($10),a
	ld	a,$80
	call	lcd_delay
	out	($10),a
	ld	b,7
int_2:
	push	bc
	push	hl
	ld	a,(hl)
	ld	e,a
	rlca
	rlca
	rlca
	ld	l,a
	ld	h,0 ;hl=sprite offset
	bit	2,e
	jr	z,int1
	ld	a,0
smc1 = $-1
	rrca
	jr	c,int1
	ld	a,24
	add	a,l
	ld	l,a
int1:
	ld	de,sprites
	add	hl,de ;hl=sprite address
	ld	b,8
int_3:
	ld	a,(hl)
	call	lcd_delay
	out	($11),a
	inc	hl
	djnz	int_3
	pop	hl
	inc	hl
	pop	bc
	djnz	int_2
	pop	bc
	inc	c
	inc	hl
	djnz	int_1

	ld	a,10
	out	(3),a
	exx
	ex	af,af'
	ei
	ret

lcd_delay:
	push	af
lcd_:
	in	a,($10)
	rlca
	jr	c,lcd_
	pop	af
	ret

sprites:
 .db $FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF
 .db $00,$00,$00,$00,$00,$00,$00,$00
 .db $FF,$81,$A5,$81,$81,$A5,$81,$FF
 .db $3C,$18,$99,$FF,$FF,$99,$18,$3C
level:
 .db $00
cont:
 .db $EE,$00,$00,$00,$00,$00,$00
 .db $AA,$55,$AA,$55,$AA,$55,$AA,$55
 .db $FF,$D5,$AF,$D5,$AB,$F5,$AB,$FF
 .db $BE,$5D,$BB,$FF,$FF,$DD,$BA,$7D
 .db $55,$AA,$55,$AA,$55,$AA,$55,$AA
 .db $FF,$AB,$F5,$AB,$D5,$AF,$D5,$FF
 .db $7D,$BA,$DD,$FF,$FF,$BB,$5D,$BE
